/**
   \file 
   \author lcs09

   \brief Test suite per le funzioni che lavorano sugli intervalli e sulle liste di intervalli
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mcheck.h>
#include "CUnit.h"
#include "TestDB.h"
#include "Basic.h"
#include "interval_suite.h"




int main(int argc, char* argv[])
{
    CU_BasicRunMode mode = CU_BRM_VERBOSE;
    unsigned int ret;
    mtrace();

    if (CU_initialize_registry()) 
	printf("\nInitialization of Test Registry failed.");
    
    add_suite_testinterval();
    
    CU_basic_set_mode(mode);
    printf("\nTests completed with return value %d.\n", CU_basic_run_tests());
    printf("\nTests failed %d.\n", ret = CU_get_number_of_tests_failed() );
    CU_cleanup_registry();

    if ( ret == 0 ) 
	return EXIT_SUCCESS;
    else
	return EXIT_FAILURE;

}
